package cn.com.qmth.stmms.ms.accesscontrol.api;

import cn.com.qmth.stmms.ms.accesscontrol.config.LoginConfig;
import cn.com.qmth.stmms.ms.core.domain.Work;
import cn.com.qmth.stmms.ms.core.domain.user.MarkUser;
import cn.com.qmth.stmms.ms.core.domain.user.Role;
import cn.com.qmth.stmms.ms.core.repository.MarkUserRepo;

import cn.com.qmth.stmms.ms.core.repository.WorkRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import java.util.Date;

/**
 * Created by zhengmin on 2016/11/1.
 */
@RestController
public class AuthApi {

    @Autowired
    private LoginConfig loginConfig;

    @Autowired
    private MarkUserRepo markUserRepo;

    @Autowired
    private WorkRepo workRepo;

    @RequestMapping(value = "login", method = RequestMethod.POST)
    public MarkUser login(@RequestBody MarkUser user, HttpServletRequest request) {
        MarkUser domain = null;
        if (loginConfig.getLoginName().equals(user.getLoginName()) &&
                loginConfig.getPassword().equals(user.getPassword())) {
            domain = new MarkUser(loginConfig.getLoginName(), loginConfig.getPassword(), null, null, "系统管理员", Role.ADMIN);
        } else {
            Work activeWork = workRepo.findByActiveTrue();
            String loginName = activeWork.getId() + "-" + user.getLoginName();
            domain = markUserRepo.findByLoginName(loginName);
            if (domain == null) {
                throw new RuntimeException("用户不存在");
            }
            if (!user.getPassword().equals(domain.getPassword())) {
                throw new RuntimeException("用户或密码错误");
            }
            if (!domain.isEnabled()) {
                throw new RuntimeException("用户被禁用");
            }
            domain.setSessionId(request.getSession().getId());
            markUserRepo.save(domain);
        }
        HttpSession session = request.getSession();
        String token = (String) request.getSession().getAttribute("token");
        if (!StringUtils.isEmpty(token)) {
            session.setAttribute("token", null);
        }
        session.setAttribute("token", new Date().getTime() + "#" + domain.getLoginName());
        return domain;
    }

    @RequestMapping(value = "/logout", method = RequestMethod.DELETE)
    public void logout(HttpServletRequest request) {
        HttpSession session = request.getSession();
        session.setAttribute("token", null);
    }

    @RequestMapping(value = "/{domain}/password", method = RequestMethod.PATCH)
    public void pwd(@PathVariable MarkUser domain, @RequestBody MarkUser markUser) {
        if (markUser.getPassword() == null || markUser.getPassword().length() < 6) {
            throw new RuntimeException("密码长度不能小于6位");
        }
        domain.setPassword(markUser.getPassword());
        domain.setPwChangedCount(markUser.getPwChangedCount() + 1);
        markUserRepo.save(domain);
    }
}
