package cn.com.qmth.stmms.ms.admin.api;

import cn.com.qmth.stmms.ms.admin.service.InspectRangeService;
import cn.com.qmth.stmms.ms.core.domain.InspectRange;
import cn.com.qmth.stmms.ms.core.repository.InspectRangeRepo;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by yuanpan on 2017/10/19.
 */
@RestController
@RequestMapping("api/admin/inspect-range")
public class InspectRangeApi {

    @Autowired
    private InspectRangeRepo inspectRangeRepo;


    @Autowired
    private InspectRangeService inspectRangeService;

    @Autowired
    private PaperRepo paperRepo;

    @GetMapping
    public List<InspectRange> list(@RequestParam Long workId) {
        return inspectRangeRepo.findByWorkId(workId);
    }

    @PostMapping
    public void create(@RequestBody InspectRange inspectRange) {

        InspectRange.InspectRangeType type = inspectRange.getType();
        Integer condition = inspectRange.getCondition();
        Long workId = inspectRange.getWorkId();

        if (type == null || condition == null || workId == null) {
            throw new RuntimeException("接口参数缺失");
        }

        //判断是否已经全部打分完成了
        long unfinishedPaperCount = paperRepo.countByWorkIdAndScoreIsNull(workId);

        if (unfinishedPaperCount > 0) {
            throw new RuntimeException("打分还没有完成，不能进行抽查工作。");
        }

        inspectRangeService.save(inspectRange);

    }

    @PutMapping(value = "{domain}")
    public void update(@PathVariable InspectRange domain, @RequestBody InspectRange inspectRange) {
        domain.setCondition(inspectRange.getCondition());
        domain.setEnabled(inspectRange.getEnabled());
        domain.setType(inspectRange.getType());
        inspectRangeService.save(domain);

    }


    //@PatchMapping(value = "{domain}/start")
    @RequestMapping(value = "{domain}/start",method = RequestMethod.PATCH)
    public void start(@PathVariable InspectRange domain) {

        domain.setEnabled(true);
        inspectRangeService.save(domain);
    }
}
