package cn.com.qmth.stmms.ms.admin.api;

import cn.com.qmth.stmms.ms.core.domain.user.MarkUser;
import cn.com.qmth.stmms.ms.core.domain.user.Role;
import cn.com.qmth.stmms.ms.core.repository.MarkUserRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by yuanpan on 2017/10/16.
 */
@RestController
@RequestMapping("api/admin/inspectors")
public class InspectorApi {

    @Autowired
    private MarkUserRepo markUserRepo;

    @GetMapping
    public List<MarkUser> list(@RequestParam Long workId) {

        return markUserRepo.findByWorkIdAndRole(workId, Role.INSPECTOR);
    }

    @PostMapping
    public void create(@RequestBody MarkUser inspectUser) {

        MarkUser inspector = markUserRepo.findByLoginName(inspectUser.getWorkId() + "-" + inspectUser.getLoginName());
        if (inspector != null) {
            throw new RuntimeException("该登录名已经存在");
        }
        inspectUser.setLoginName(inspectUser.getWorkId() + "-" + inspectUser.getLoginName());
        markUserRepo.save(inspectUser);

    }
}
